package main

import "core:math"
import rl "vendor:raylib" 

Vec3 :: [3]f32

Entity :: struct {
	position : Vec3,
	velocity : Vec3,
	size : Vec3,
	update : proc(entity: ^Entity, delta: f32),
}

PAL_INT :: [6]u32 {
	0x272744ff,
	0x494d7eff,
	0x8b6d9cff,
	0xc69fa5ff,
	0xf2d3abff,
	0xfbf5efff,
}

PAL := [6]rl.Color{}

main :: proc() {
	for v, i in PAL_INT {
		PAL[i] = rl.GetColor(v)
	}

	rl.InitWindow(800, 400, "By The Fire")
	rl.SetTargetFPS(60)

	player := player_create()

	rl.DisableCursor()

	for !rl.WindowShouldClose() {
		using rl 
		player_update(&player, GetFrameTime())

		BeginDrawing()
		BeginMode3D(player.camera)

			ClearBackground(PAL[0])
			DrawPlane({0, 0, 0}, {32,32}, PAL[1])

		EndMode3D()
		EndDrawing()
	}
}
